Subject: Re: [PATCH v2] ASoC: fsl_esai: Add ESAI CPU DAI driver

From: Mark Brown <[email-masked]>
Date: Thu, 9 Jan 2014 18:44:53 +0000

On Thu, Jan 09, 2014 at 06:57:58PM +0800, Nicolin Chen wrote:

> +/**
> + * This function configures the ratio between MCLK (HCK) and BCLK (SCK)
> + * (For DAI Master Mode only)
> + *
> + * Note: Machine driver should calculate the ratio to call this function.
> + * 	 Only effective after calling set_dai_sysclk() to set HCK direction.
> + */
> +static int fsl_esai_set_bclk_ratio(struct snd_soc_dai *dai, unsigned int ratio)

Why does the machine driver have to do this by hand, being able to
override is fine but having sensible defaults is easier?  Or does it
actually do that and the comment just needs updating?

> +	ret = devm_snd_soc_register_component(&pdev->dev, &fsl_esai_component,
> +					      &fsl_esai_dai, 1);
> +	if (ret) {
> +		dev_err(&pdev->dev, "failed to register DAI: %d\n", ret);
> +		return ret;
> +	}
> +
> +	ret = imx_pcm_dma_init(pdev);
> +	if (ret)
> +		dev_err(&pdev->dev, "failed to init imx pcm dma: %d\n", ret);
> +
> +	/* Reset ESAI unit */
> +	regmap_write(esai_priv->regmap, REG_ESAI_ECR, ESAI_ECR_ERST);
> +
> +	/*
> +	 * We need to enable ESAI so as to access some of its registers.
> +	 * Otherwise, we would fail to dump regmap from user space.
> +	 */
> +	regmap_write(esai_priv->regmap, REG_ESAI_ECR, ESAI_ECR_ESAIEN);

I would expect to see the hardware initialisation before we start
registering with the core otherwise the core might start trying to run
prior to the hardware being initialised.

Otherwise this looks good.